/*
 *  include/linux/virtinfo.h
 *
 *  Copyright (C) 2005  SWsoft
 *  All rights reserved.
 *  
 *  Licensing governed by "linux/COPYING.SWsoft" file.
 *
 */

#ifndef __LINUX_VIRTINFO_H
#define __LINUX_VIRTINFO_H

#include <linux/kernel.h>
#include <linux/page-flags.h>
#include <linux/rwsem.h>
#include <linux/notifier.h>

void virtinfo_notifier_register(int type, struct notifier_block *nb);
void virtinfo_notifier_unregister(int type, struct notifier_block *nb);
int virtinfo_notifier_call(int type, unsigned long n, void *data);

struct meminfo {
	struct sysinfo si;
	unsigned long active, inactive;
	unsigned long cache, swapcache;
	unsigned long committed_space;
	struct page_state ps;
	unsigned long vmalloc_total, vmalloc_used, vmalloc_largest;
};

#define VIRTINFO_MEMINFO	0
#define VIRTINFO_ENOUGHMEM	1
#define VIRTINFO_OUTOFMEM	2
#define VIRTINFO_EXITMMAP	3
#define VIRTINFO_EXECMMAP	4
#define VIRTINFO_SYSINFO	5

enum virt_info_types {
	VITYPE_GENERAL,
	VITYPE_FAUDIT,
	VITYPE_QUOTA,

	VIRT_TYPES
};

#endif /* __LINUX_VIRTINFO_H */
